//  Copyright (C) 2003 Koji Tsukada and Satoru Takabayashi
//      All rights reserved.
//      This is free software with ABSOLUTELY NO WARRANTY.
//
//  You can redistribute it and/or modify it under the terms of
//  the GNU General Public License version 2.

using System;
using System.Diagnostics;

namespace FaceIcon
{

	public class Config
	{
		string dataDirectory = 
			Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData) + "\\" + "FaceIcon";

		string programDirectory;
		public string ProgramDirectory
		{
			get
			{
				if (programDirectory != null)
				{ 
					return programDirectory;
				}
				else
				{
					
					return Environment.CurrentDirectory;
				}
			}
			set 
			{
				programDirectory = value;
			}
		}

		public string ProgramPath
		{
			get
			{
				return this.ProgramDirectory + "\\" + Process.GetCurrentProcess().ProcessName;
			}
		}

		public string UserProfilePath
		{
			get
			{
				return this.dataDirectory + "\\" + "UserProfile.txt";
			}
		}

		public string IconDirectory
		{
			get
			{
				return this.dataDirectory + "\\" + "Icons";
			}
		}

		public string LogPath
		{
			get
			{
				return this.dataDirectory + "\\" + "FaceIconLog.txt";
			}
		}

	}
}
