//  Copyright (C) 2003 Koji Tsukada and Satoru Takabayashi
//      All rights reserved.
//      This is free software with ABSOLUTELY NO WARRANTY.
//
//  You can redistribute it and/or modify it under the terms of
//  the GNU General Public License version 2.

using System;
using System.Windows.Forms;

namespace FaceIcon
{
	/// <summary>
	/// FaceIcon ̊Tv̐łB
	/// </summary>
	public class FaceIcon
	{
		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main(string[] args) 
		{
			Getopt getopt = new Getopt("nadm", args);
			string name = getopt.Get('n');
			string address = getopt.Get('a');
			string directory = getopt.Get('d');
			string mobileAddress = getopt.Get('m');

			string[] filenames = getopt.Remains();
			Config config = new Config();
			if (name != null && address != null && directory != null) 
			{
				config.ProgramDirectory = directory;
				UserProfile userProfile = LoadUserProfile(config);
				TargetProfile targetProfile = CreateTargetProfile(config, name, address, mobileAddress);
				if (filenames.Length > 0)
					Application.Run(new FileTransferForm(config, userProfile, targetProfile, filenames));
				else
					Application.Run(new MessagingForm(config, userProfile, targetProfile));
			}
			else
			{
				UserProfile userProfile = null;
				if (IsUserProfileFileExists(config.UserProfilePath))
					userProfile = LoadUserProfile(config);
				Application.Run(new ConfigForm(config, userProfile, null));
			}
		}

		private static bool IsUserProfileFileExists (string fileName)
		{
			return System.IO.File.Exists(fileName);
		}

		private static TargetProfile CreateTargetProfile (Config config, string name, string address, string mobileAddress)
		{
			TargetProfile profile = new TargetProfile();
			profile.Name = name;
			profile.Address = address;
			string iconPath = config.IconDirectory + "\\" + name + ".ico";
			if (System.IO.File.Exists(iconPath))
				profile.IconPath = iconPath;
			profile.MobileAddress = mobileAddress;
			return profile;
		}

		private static UserProfile LoadUserProfile (Config config) 
		{
			UserProfile profile = new UserProfile();
			try 
			{
				profile.Load(config);
			}
			catch (Exception e)
			{
				MessageBox.Show("pݒt@C̓ǂݍ݂Ɏs܂\n" + e.Message);
				throw e;
			}
			return profile;
		}
	}
}
