//  Copyright (C) 2003 Koji Tsukada and Satoru Takabayashi
//      All rights reserved.
//      This is free software with ABSOLUTELY NO WARRANTY.
//
//  You can redistribute it and/or modify it under the terms of
//  the GNU General Public License version 2.

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Web.Mail; 
using System.Globalization;
using System.Threading;
using System.IO;
using System.Diagnostics;
using System.Text;

namespace FaceIcon
{

	public class FileTransferForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.Windows.Forms.Label messageLabel;
		private System.Windows.Forms.LinkLabel AddMessageLabel;
		private System.Windows.Forms.LinkLabel CancelLabel;

		string[] inputFilenames;
		int sleepTime = 100;
		TargetProfile targetProfile;
		UserProfile userProfile;
		Config config;

		Thread mailSender;
		bool canceled = false, finished = false;

		public FileTransferForm(Config config, UserProfile userProfile, TargetProfile targetProfile, string[] filenames)
		{
			InitializeComponent();

			this.userProfile = userProfile;
			this.targetProfile = targetProfile;
			this.config = config;
			inputFilenames = filenames;
			mailSender = new Thread(new ThreadStart(SendMailAndExit));
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FileTransferForm));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.messageLabel = new System.Windows.Forms.Label();
			this.AddMessageLabel = new System.Windows.Forms.LinkLabel();
			this.CancelLabel = new System.Windows.Forms.LinkLabel();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(32, 8);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(48, 48);
			this.pictureBox1.TabIndex = 2;
			this.pictureBox1.TabStop = false;
			// 
			// messageLabel
			// 
			this.messageLabel.Location = new System.Drawing.Point(0, 64);
			this.messageLabel.Name = "messageLabel";
			this.messageLabel.Size = new System.Drawing.Size(120, 16);
			this.messageLabel.TabIndex = 4;
			this.messageLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// AddMessageLabel
			// 
			this.AddMessageLabel.Location = new System.Drawing.Point(16, 88);
			this.AddMessageLabel.Name = "AddMessageLabel";
			this.AddMessageLabel.Size = new System.Drawing.Size(96, 16);
			this.AddMessageLabel.TabIndex = 5;
			this.AddMessageLabel.TabStop = true;
			this.AddMessageLabel.Text = "bZ[WY";
			this.AddMessageLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.AddMessageLabel_LinkClicked);
			// 
			// CancelLabel
			// 
			this.CancelLabel.Location = new System.Drawing.Point(15, 104);
			this.CancelLabel.Name = "CancelLabel";
			this.CancelLabel.Size = new System.Drawing.Size(96, 16);
			this.CancelLabel.TabIndex = 6;
			this.CancelLabel.TabStop = true;
			this.CancelLabel.Text = "LZ";
			this.CancelLabel.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.CancelLabel_LinkClicked);
			// 
			// FileTransferForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(118, 123);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.CancelLabel,
																		  this.AddMessageLabel,
																		  this.messageLabel,
																		  this.pictureBox1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FileTransferForm";
			this.Text = "title";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion


		private void Form1_Load(object sender, System.EventArgs e)
		{
			if (targetProfile.IconPath != null)
				LoadFaceIcon();
			this.Text = targetProfile.Name;
			mailSender.Start();
		}

		private void LoadFaceIcon ()
		{
			try
			{
				if (System.IO.File.Exists(targetProfile.IconPath))
				{
					Util.LoadImage(pictureBox1, targetProfile.IconPath);
					Util.LoadIcon(this, targetProfile.IconPath);
				}
			}
			catch (Exception e)
			{
				MessageBox.Show("ACRt@C̓ǂݍ݂Ɏs܂\n" + e.Message);
				Application.Exit();
			}
		}

		private void SendMail(string bodyMessage)
		{
			MailMessage mail = new MailMessage();
			mail.From = userProfile.Address;
			mail.To = targetProfile.Address;
			mail.Subject = "FaceIcon: " + (new FileInfo(inputFilenames[0])).Name;

			if (inputFilenames.Length > 1) 
				mail.Subject += " Ȃ";
			foreach (string filename in inputFilenames) 
					mail.Attachments.Add(new MailAttachment(filename));
			mail.Body = bodyMessage;

			SmtpMail.SmtpServer = userProfile.SmtpHost;
			SmtpMail.Send(mail);

// FIXME: to be completed.
//			MailSender sender = new MailSender(userProfile.SmtpHost);
//			sender.Send(mail);

//			SendingForm form = new SendingForm(config, userProfile, targetProfile);
//			form.ShowDialog();
//			form.Close();
			DoLogging();
		}

		private void SendMailAndExit()
		{
			for (int i = 0; i < 5; i++) 
			{
				messageLabel.Text = "M܂ł" + (5 -i) + "b";
				Thread.Sleep(1000);

				if(canceled || finished)
					return;
			}

			messageLabel.Text = "[𑗐Mł";
			try 
			{
				string message = userProfile.Name + "񂩂Ytt@CłB";
				SendMail(message);
			} 
			catch (Exception ex)
			{
				MessageBox.Show("MɎs܂DSMTPT[o[̐ݒȂǂmFĂD" + "\n" + ex.Message);
				Application.Exit();
			}
			messageLabel.Text = "M܂";
			Thread.Sleep(sleepTime); 
			Application.Exit();
		}

		private void DoNothing()
		{
			messageLabel.Text = "ݒ蒆ł";
			Thread.Sleep(sleepTime);
			Application.Exit();
		}

		private string GetDateString()
		{
			// s :2000-08-17T16:32:32
			return DateTime.Now.ToString("s", DateTimeFormatInfo.InvariantInfo);
		}

		private void DoLogging()
		{
			string processName = Process.GetCurrentProcess().ProcessName;
			string currentDirectory = Environment.CurrentDirectory;
			string logMessage = GetDateString() + ": " + userProfile.Address + " -> " +
								targetProfile.Address + ": " + String.Join(" ", inputFilenames);

			StreamWriter writer = new StreamWriter(config.LogPath, true);
			writer.WriteLine(logMessage);
			writer.Close();
		}

		private void CancelLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			canceled = true;
			Application.Exit();
		}

		private void AddMessageLabel_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			mailSender.Abort();
			this.messageLabel.Text = "bZ[WY܂";
			this.Hide();
			MessageAdditionForm form = new MessageAdditionForm(config, userProfile, targetProfile);
			form.ShowDialog();
			if(form.DialogResult ==DialogResult.OK)
			{
				try
				{
					SendMail(form.Message);
				}
				catch (Exception ex)
				{
					MessageBox.Show("MɎs܂DSMTPT[o[̐ݒȂǂmFĂD" + "\n" + ex.Message);
					Application.Exit();
				}

			}
			finished = true;

			Application.Exit();
		}
	}
}
