//  Copyright (C) 2003 Koji Tsukada and Satoru Takabayashi
//      All rights reserved.
//      This is free software with ABSOLUTELY NO WARRANTY.
//
//  You can redistribute it and/or modify it under the terms of
//  the GNU General Public License version 2.

using System;
using System.IO;

namespace FaceIcon
{
	/// <summary>
	/// Profile ̊Tv̐łB
	/// </summary>
	public class Profile
	{
		string name;
		public string Name
		{
			get 
			{
				return name;
			}
			set
			{
				name = value;
			}
		}

		string address;
		public string Address
		{
			get 
			{
				return address;
			}
			set
			{
				address = value;
			}
		}

		public string FullAddress
		{
			get
			{
				return "<" + address + ">" + " " + name;
			}
		}
	}

	public class UserProfile : Profile
	{
		string smtpHost;
		public string SmtpHost
		{
			get
			{
				return smtpHost;
			}
			set 
			{
				smtpHost = value;
			}
		}

		public void Load (Config config)
		{
			StreamReader reader = new StreamReader(config.UserProfilePath);
			this.Name = reader.ReadLine();
			this.Address = reader.ReadLine();
			this.SmtpHost = reader.ReadLine();
			reader.Close();
		}

		public void Save (Config config)
		{
			StreamWriter writer = new StreamWriter(config.UserProfilePath);
			writer.WriteLine(this.Name);
			writer.WriteLine(this.Address);
			writer.WriteLine(this.SmtpHost);
			writer.Close();
		}
	}

	public class TargetProfile : Profile
	{
		string iconPath;
		public string IconPath
		{
			get
			{
				return iconPath;
			}
			set 
			{
				iconPath = value;
			}
		}

		string mobileAddress;
		public string MobileAddress
		{
			get 
			{
				return mobileAddress;
			}
			set
			{
				mobileAddress = value;
			}
		}

		public void Save(Config config)
		{
			string desktopPath =
				Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
			string arguments = "-n" + " \"" + this.Name + "\" " +
				"-a" + " \"" + this.Address + "\" " +
				"-m" + " \"" + this.MobileAddress + "\" " + 
				"-d" + " \"" + config.ProgramDirectory + "\"";
			string shortcutPath = desktopPath + "\\" + this.Name + ".lnk";

			if (System.IO.File.Exists(shortcutPath))
				System.IO.File.Delete(shortcutPath);
			Util.CreateShortcut(config.ProgramPath,
				arguments,
				shortcutPath,
				"",
				this.IconPath,
				this.Name + "̊ACRł");
		}
	}
}
